|
|
- #!/bin/bash
- # The iTerm2 customizations fall under the following license:
- #
- # This program is free software; you can redistribute it and/or
- # modify it under the terms of the GNU General Public License
- # as published by the Free Software Foundation; either version 2
- # of the License, or (at your option) any later version.
- #
- # This program is distributed in the hope that it will be useful,
- # but WITHOUT ANY WARRANTY; without even the implied warranty of
- # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
- # GNU General Public License for more details.
- #
- # You should have received a copy of the GNU General Public License
- # along with this program; if not, write to the Free Software
- # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-
-
- # -- BEGIN ITERM2 CUSTOMIZATIONS --
- if [[ "$ITERM_ENABLE_SHELL_INTEGRATION_WITH_TMUX""$TERM" != screen && "$ITERM_SHELL_INTEGRATION_INSTALLED" = "" && "$-" == *i* && "$TERM" != linux && "$TERM" != dumb ]]; then
-
- if shopt extdebug | grep on > /dev/null; then
- echo "iTerm2 Shell Integration not installed."
- echo ""
- echo "Your shell has 'extdebug' turned on."
- echo "This is incompatible with shell integration."
- echo "Find 'shopt -s extdebug' in bash's rc scripts and remove it."
- return 0
- fi
-
- ITERM_SHELL_INTEGRATION_INSTALLED=Yes
- # Saved copy of your PS1. This is used to detect if the user changes PS1
- # directly. ITERM_PREV_PS1 will hold the last value that this script set PS1 to
- # (including various custom escape sequences).
- ITERM_PREV_PS1="$PS1"
-
- # The following chunk of code, bash-preexec.sh, is licensed like this:
- # The MIT License
- #
- # Copyright (c) 2015 Ryan Caloras and contributors (see https://github.com/rcaloras/bash-preexec)
- #
- # Permission is hereby granted, free of charge, to any person obtaining a copy
- # of this software and associated documentation files (the "Software"), to deal
- # in the Software without restriction, including without limitation the rights
- # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
- # copies of the Software, and to permit persons to whom the Software is
- # furnished to do so, subject to the following conditions:
- #
- # The above copyright notice and this permission notice shall be included in
- # all copies or substantial portions of the Software.
- #
- # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
- # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
- # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
- # THE SOFTWARE.
-
- # Wrap bash-preexec.sh in a function so that, if it exits early due to having
- # been sourced elsewhere, it doesn't exit our entire script.
- _install_bash_preexec () {
- # -- BEGIN BASH-PREEXEC.SH --
- #!/bin/bash
- #
- # bash-preexec.sh -- Bash support for ZSH-like 'preexec' and 'precmd' functions.
- # https://github.com/rcaloras/bash-preexec
- #
- #
- # 'preexec' functions are executed before each interactive command is
- # executed, with the interactive command as its argument. The 'precmd'
- # function is executed before each prompt is displayed.
- #
- # Author: Ryan Caloras (ryan@bashhub.com)
- # Forked from Original Author: Glyph Lefkowitz
- #
- # V0.3.7
- #
- # -- END ITERM2 CUSTOMIZATIONS --
-
- # bash-preexec.sh -- Bash support for ZSH-like 'preexec' and 'precmd' functions.
- # https://github.com/rcaloras/bash-preexec
- #
- #
- # 'preexec' functions are executed before each interactive command is
- # executed, with the interactive command as its argument. The 'precmd'
- # function is executed before each prompt is displayed.
- #
- # Author: Ryan Caloras (ryan@bashhub.com)
- # Forked from Original Author: Glyph Lefkowitz
- #
- # V0.3.7
- #
-
- # General Usage:
- #
- # 1. Source this file at the end of your bash profile so as not to interfere
- # with anything else that's using PROMPT_COMMAND.
- #
- # 2. Add any precmd or preexec functions by appending them to their arrays:
- # e.g.
- # precmd_functions+=(my_precmd_function)
- # precmd_functions+=(some_other_precmd_function)
- #
- # preexec_functions+=(my_preexec_function)
- #
- # 3. Consider changing anything using the DEBUG trap or PROMPT_COMMAND
- # to use preexec and precmd instead. Preexisting usages will be
- # preserved, but doing so manually may be less surprising.
- #
- # Note: This module requires two Bash features which you must not otherwise be
- # using: the "DEBUG" trap, and the "PROMPT_COMMAND" variable. If you override
- # either of these after bash-preexec has been installed it will most likely break.
-
- # Avoid duplicate inclusion
- if [[ "${__bp_imported:-}" == "defined" ]]; then
- return 0
- fi
- __bp_imported="defined"
-
- # Should be available to each precmd and preexec
- # functions, should they want it. $? and $_ are available as $? and $_, but
- # $PIPESTATUS is available only in a copy, $BP_PIPESTATUS.
- # TODO: Figure out how to restore PIPESTATUS before each precmd or preexec
- # function.
- __bp_last_ret_value="$?"
- BP_PIPESTATUS=("${PIPESTATUS[@]}")
- __bp_last_argument_prev_command="$_"
-
- __bp_inside_precmd=0
- __bp_inside_preexec=0
-
- # Fails if any of the given variables are readonly
- # Reference https://stackoverflow.com/a/4441178
- __bp_require_not_readonly() {
- local var
- for var; do
- if ! ( unset "$var" 2> /dev/null ); then
- echo "iTerm2 Shell Integration:bash-preexec requires write access to ${var}" >&2
- return 1
- fi
- done
- }
-
- # Remove ignorespace and or replace ignoreboth from HISTCONTROL
- # so we can accurately invoke preexec with a command from our
- # history even if it starts with a space.
- __bp_adjust_histcontrol() {
- local histcontrol
- histcontrol="${HISTCONTROL//ignorespace}"
- # Replace ignoreboth with ignoredups
- if [[ "$histcontrol" == *"ignoreboth"* ]]; then
- histcontrol="ignoredups:${histcontrol//ignoreboth}"
- fi;
- export HISTCONTROL="$histcontrol"
- }
-
- # This variable describes whether we are currently in "interactive mode";
- # i.e. whether this shell has just executed a prompt and is waiting for user
- # input. It documents whether the current command invoked by the trace hook is
- # run interactively by the user; it's set immediately after the prompt hook,
- # and unset as soon as the trace hook is run.
- __bp_preexec_interactive_mode=""
-
- __bp_trim_whitespace() {
- local var=$@
- var="${var#"${var%%[![:space:]]*}"}" # remove leading whitespace characters
- var="${var%"${var##*[![:space:]]}"}" # remove trailing whitespace characters
- echo -n "$var"
- }
-
- # This function is installed as part of the PROMPT_COMMAND;
- # It sets a variable to indicate that the prompt was just displayed,
- # to allow the DEBUG trap to know that the next command is likely interactive.
- __bp_interactive_mode() {
- __bp_preexec_interactive_mode="on";
- }
-
-
- # This function is installed as part of the PROMPT_COMMAND.
- # It will invoke any functions defined in the precmd_functions array.
- __bp_precmd_invoke_cmd() {
- # Save the returned value from our last command, and from each process in
- # its pipeline. Note: this MUST be the first thing done in this function.
- __bp_last_ret_value="$?" BP_PIPESTATUS=("${PIPESTATUS[@]}")
-
- # Don't invoke precmds if we are inside an execution of an "original
- # prompt command" by another precmd execution loop. This avoids infinite
- # recursion.
- if (( __bp_inside_precmd > 0 )); then
- return
- fi
- local __bp_inside_precmd=1
-
- # Invoke every function defined in our function array.
- local precmd_function
- for precmd_function in "${precmd_functions[@]}"; do
-
- # Only execute this function if it actually exists.
- # Test existence of functions with: declare -[Ff]
- if type -t "$precmd_function" 1>/dev/null; then
- __bp_set_ret_value "$__bp_last_ret_value" "$__bp_last_argument_prev_command"
- # Quote our function invocation to prevent issues with IFS
- "$precmd_function"
- fi
- done
- }
-
- # Sets a return value in $?. We may want to get access to the $? variable in our
- # precmd functions. This is available for instance in zsh. We can simulate it in bash
- # by setting the value here.
- __bp_set_ret_value() {
- return ${1:-}
- }
-
- __bp_in_prompt_command() {
-
- local prompt_command_array
- IFS=';' read -ra prompt_command_array <<< "$PROMPT_COMMAND"
-
- local trimmed_arg
- trimmed_arg=$(__bp_trim_whitespace "${1:-}")
-
- local command
- for command in "${prompt_command_array[@]:-}"; do
- local trimmed_command
- trimmed_command=$(__bp_trim_whitespace "$command")
- # Only execute each function if it actually exists.
- if [[ "$trimmed_command" == "$trimmed_arg" ]]; then
- return 0
- fi
- done
-
- return 1
- }
-
- # This function is installed as the DEBUG trap. It is invoked before each
- # interactive prompt display. Its purpose is to inspect the current
- # environment to attempt to detect if the current command is being invoked
- # interactively, and invoke 'preexec' if so.
- __bp_preexec_invoke_exec() {
- # Save the contents of $_ so that it can be restored later on.
- # https://stackoverflow.com/questions/40944532/bash-preserve-in-a-debug-trap#40944702
- __bp_last_argument_prev_command="${1:-}"
- # Don't invoke preexecs if we are inside of another preexec.
- if (( __bp_inside_preexec > 0 )); then
- return
- fi
- local __bp_inside_preexec=1
-
- # Checks if the file descriptor is not standard out (i.e. '1')
- # __bp_delay_install checks if we're in test. Needed for bats to run.
- # Prevents preexec from being invoked for functions in PS1
- if [[ ! -t 1 && -z "${__bp_delay_install:-}" ]]; then
- return
- fi
-
- if [[ -n "${COMP_LINE:-}" ]]; then
- # We're in the middle of a completer. This obviously can't be
- # an interactively issued command.
- return
- fi
- if [[ -z "${__bp_preexec_interactive_mode:-}" ]]; then
- # We're doing something related to displaying the prompt. Let the
- # prompt set the title instead of me.
- return
- else
- # If we're in a subshell, then the prompt won't be re-displayed to put
- # us back into interactive mode, so let's not set the variable back.
- # In other words, if you have a subshell like
- # (sleep 1; sleep 2)
- # You want to see the 'sleep 2' as a set_command_title as well.
- if [[ 0 -eq "${BASH_SUBSHELL:-}" ]]; then
- __bp_preexec_interactive_mode=""
- fi
- fi
-
- if __bp_in_prompt_command "${BASH_COMMAND:-}"; then
- # If we're executing something inside our prompt_command then we don't
- # want to call preexec. Bash prior to 3.1 can't detect this at all :/
- __bp_preexec_interactive_mode=""
- return
- fi
-
- local this_command
- this_command=$(
- export LC_ALL=C
- HISTTIMEFORMAT= builtin history 1 | sed '1 s/^ *[0-9][0-9]*[* ] //'
- )
-
- # Sanity check to make sure we have something to invoke our function with.
- if [[ -z "$this_command" ]]; then
- return
- fi
-
- # If none of the previous checks have returned out of this function, then
- # the command is in fact interactive and we should invoke the user's
- # preexec functions.
-
- # Invoke every function defined in our function array.
- local preexec_function
- local preexec_function_ret_value
- local preexec_ret_value=0
- for preexec_function in "${preexec_functions[@]:-}"; do
-
- # Only execute each function if it actually exists.
- # Test existence of function with: declare -[fF]
- if type -t "$preexec_function" 1>/dev/null; then
- __bp_set_ret_value ${__bp_last_ret_value:-}
- # Quote our function invocation to prevent issues with IFS
- "$preexec_function" "$this_command"
- preexec_function_ret_value="$?"
- if [[ "$preexec_function_ret_value" != 0 ]]; then
- preexec_ret_value="$preexec_function_ret_value"
- fi
- fi
- done
-
- # Restore the last argument of the last executed command, and set the return
- # value of the DEBUG trap to be the return code of the last preexec function
- # to return an error.
- # If `extdebug` is enabled a non-zero return value from any preexec function
- # will cause the user's command not to execute.
- # Run `shopt -s extdebug` to enable
- __bp_set_ret_value "$preexec_ret_value" "$__bp_last_argument_prev_command"
- }
-
- __bp_install() {
- # Exit if we already have this installed.
- if [[ "${PROMPT_COMMAND:-}" == *"__bp_precmd_invoke_cmd"* ]]; then
- return 1;
- fi
-
- trap '__bp_preexec_invoke_exec "$_"' DEBUG
-
- # Preserve any prior DEBUG trap as a preexec function
- local prior_trap=$(sed "s/[^']*'\(.*\)'[^']*/\1/" <<<"${__bp_trap_string:-}")
- unset __bp_trap_string
- if [[ -n "$prior_trap" ]]; then
- eval '__bp_original_debug_trap() {
- '"$prior_trap"'
- }'
- preexec_functions+=(__bp_original_debug_trap)
- fi
-
- # Adjust our HISTCONTROL Variable if needed.
- __bp_adjust_histcontrol
-
-
- # Issue #25. Setting debug trap for subshells causes sessions to exit for
- # backgrounded subshell commands (e.g. (pwd)& ). Believe this is a bug in Bash.
- #
- # Disabling this by default. It can be enabled by setting this variable.
- if [[ -n "${__bp_enable_subshells:-}" ]]; then
-
- # Set so debug trap will work be invoked in subshells.
- set -o functrace > /dev/null 2>&1
- shopt -s extdebug > /dev/null 2>&1
- fi;
-
- # Install our hooks in PROMPT_COMMAND to allow our trap to know when we've
- # actually entered something.
- PROMPT_COMMAND="__bp_precmd_invoke_cmd; __bp_interactive_mode"
-
- # Add two functions to our arrays for convenience
- # of definition.
- precmd_functions+=(precmd)
- preexec_functions+=(preexec)
-
- # Since this function is invoked via PROMPT_COMMAND, re-execute PC now that it's properly set
- eval "$PROMPT_COMMAND"
- }
-
- # Sets our trap and __bp_install as part of our PROMPT_COMMAND to install
- # after our session has started. This allows bash-preexec to be included
- # at any point in our bash profile. Ideally we could set our trap inside
- # __bp_install, but if a trap already exists it'll only set locally to
- # the function.
- __bp_install_after_session_init() {
-
- # Make sure this is bash that's running this and return otherwise.
- if [[ -z "${BASH_VERSION:-}" ]]; then
- return 1;
- fi
-
- # bash-preexec needs to modify these variables in order to work correctly
- # if it can't, just stop the installation
- __bp_require_not_readonly PROMPT_COMMAND HISTCONTROL HISTTIMEFORMAT || return
-
- # If there's an existing PROMPT_COMMAND capture it and convert it into a function
- # So it is preserved and invoked during precmd.
- if [[ -n "$PROMPT_COMMAND" ]]; then
- eval '__bp_original_prompt_command() {
- '"$PROMPT_COMMAND"'
- }'
- precmd_functions+=(__bp_original_prompt_command)
- fi
-
- # Installation is finalized in PROMPT_COMMAND, which allows us to override the DEBUG
- # trap. __bp_install sets PROMPT_COMMAND to its final value, so these are only
- # invoked once.
- # It's necessary to clear any existing DEBUG trap in order to set it from the install function.
- # Using \n as it's the most universal delimiter of bash commands
- PROMPT_COMMAND=$'\n__bp_trap_string="$(trap -p DEBUG)"\ntrap DEBUG\n__bp_install\n'
- }
-
- # Run our install so long as we're not delaying it.
- if [[ -z "$__bp_delay_install" ]]; then
- __bp_install_after_session_init
- fi;
- # -- END BASH-PREEXEC.SH --
- }
- _install_bash_preexec
- unset -f _install_bash_preexec
-
- # -- BEGIN ITERM2 CUSTOMIZATIONS --
-
- # We don't care about whitespace, but users care about not changing their histcontrol variables.
- # We overwrite the upstream __bp_adjust_histcontrol function whcih gets called from the next
- # PROMPT_COMMAND invocation.
- function __bp_adjust_histcontrol() {
- true
- }
-
- function iterm2_begin_osc {
- printf "\033]"
- }
-
- function iterm2_end_osc {
- printf "\007"
- }
-
- function iterm2_print_state_data() {
- iterm2_begin_osc
- printf "1337;RemoteHost=%s@%s" "$USER" "$iterm2_hostname"
- iterm2_end_osc
-
- iterm2_begin_osc
- printf "1337;CurrentDir=%s" "$PWD"
- iterm2_end_osc
-
- iterm2_print_user_vars
- }
-
- # Usage: iterm2_set_user_var key value
- function iterm2_set_user_var() {
- iterm2_begin_osc
- printf "1337;SetUserVar=%s=%s" "$1" $(printf "%s" "$2" | base64 | tr -d '\n')
- iterm2_end_osc
- }
-
- if [ -z "$(type -t iterm2_print_user_vars)" ] || [ "$(type -t iterm2_print_user_vars)" != function ]; then
- # iterm2_print_user_vars is not already defined. Provide a no-op default version.
- #
- # Users can write their own version of this function. It should call
- # iterm2_set_user_var but not produce any other output.
- function iterm2_print_user_vars() {
- true
- }
- fi
-
- function iterm2_prompt_prefix() {
- iterm2_begin_osc
- printf "133;D;\$?"
- iterm2_end_osc
- }
-
- function iterm2_prompt_mark() {
- iterm2_begin_osc
- printf "133;A"
- iterm2_end_osc
- }
-
- function iterm2_prompt_suffix() {
- iterm2_begin_osc
- printf "133;B"
- iterm2_end_osc
- }
-
- function iterm2_print_version_number() {
- iterm2_begin_osc
- printf "1337;ShellIntegrationVersion=14;shell=bash"
- iterm2_end_osc
- }
-
-
- # If hostname -f is slow on your system, set iterm2_hostname before sourcing this script.
- if [ -z "${iterm2_hostname:-}" ]; then
- iterm2_hostname=$(hostname -f 2>/dev/null)
- # some flavors of BSD (i.e. NetBSD and OpenBSD) don't have the -f option
- if [ $? -ne 0 ]; then
- iterm2_hostname=$(hostname)
- fi
- fi
-
- # Runs after interactively edited command but before execution
- __iterm2_preexec() {
- # Save the returned value from our last command
- __iterm2_last_ret_value="$?"
-
- iterm2_begin_osc
- printf "133;C;"
- iterm2_end_osc
- # If PS1 still has the value we set it to in iterm2_preexec_invoke_cmd then
- # restore it to its original value. It might have changed if you have
- # another PROMPT_COMMAND (like liquidprompt) that modifies PS1.
- if [ -n "${ITERM_ORIG_PS1+xxx}" -a "$PS1" = "$ITERM_PREV_PS1" ]
- then
- export PS1="$ITERM_ORIG_PS1"
- fi
- iterm2_ran_preexec="yes"
-
- __bp_set_ret_value "$__iterm2_last_ret_value" "$__bp_last_argument_prev_command"
- }
-
- function __iterm2_precmd () {
- __iterm2_last_ret_value="$?"
-
- # Work around a bug in CentOS 7.2 where preexec doesn't run if you press
- # ^C while entering a command.
- if [[ -z "${iterm2_ran_preexec:-}" ]]
- then
- __iterm2_preexec ""
- fi
- iterm2_ran_preexec=""
-
-
-
- # This is an iTerm2 addition to try to work around a problem in the
- # original preexec.bash.
- # When the PS1 has command substitutions, this gets invoked for each
- # substitution and each command that's run within the substitution, which
- # really adds up. It would be great if we could do something like this at
- # the end of this script:
- # PS1="$(iterm2_prompt_prefix)$PS1($iterm2_prompt_suffix)"
- # and have iterm2_prompt_prefix set a global variable that tells precmd not to
- # output anything and have iterm2_prompt_suffix reset that variable.
- # Unfortunately, command substitutions run in subshells and can't
- # communicate to the outside world.
- # Instead, we have this workaround. We save the original value of PS1 in
- # $ITERM_ORIG_PS1. Then each time this function is run (it's called from
- # PROMPT_COMMAND just before the prompt is shown) it will change PS1 to a
- # string without any command substitutions by doing eval on ITERM_ORIG_PS1. At
- # this point ITERM_PREEXEC_INTERACTIVE_MODE is still the empty string, so preexec
- # won't produce output for command substitutions.
-
- # The first time this is called ITERM_ORIG_PS1 is unset. This tests if the variable
- # is undefined (not just empty) and initializes it. We can't initialize this at the
- # top of the script because it breaks with liquidprompt. liquidprompt wants to
- # set PS1 from a PROMPT_COMMAND that runs just before us. Setting ITERM_ORIG_PS1
- # at the top of the script will overwrite liquidprompt's PS1, whose value would
- # never make it into ITERM_ORIG_PS1. Issue 4532. It's important to check
- # if it's undefined before checking if it's empty because some users have
- # bash set to error out on referencing an undefined variable.
- if [ -z "${ITERM_ORIG_PS1+xxx}" ]
- then
- # ITERM_ORIG_PS1 always holds the last user-set value of PS1.
- # You only get here on the first time iterm2_preexec_invoke_cmd is called.
- export ITERM_ORIG_PS1="$PS1"
- fi
-
- # If you want to generate PS1 dynamically from PROMPT_COMMAND, the best way
- # to do it is to define a function named iterm2_generate_ps1 that sets PS1.
- # Issue 5964. Other shells don't have this issue because they don't need
- # such extremes to get precmd and preexec.
- if [ -n "$(type -t iterm2_generate_ps1)" ] && [ "$(type -t iterm2_generate_ps1)" = function ]; then
- iterm2_generate_ps1
- fi
-
-
- if [[ "$PS1" != "$ITERM_PREV_PS1" ]]
- then
- export ITERM_ORIG_PS1="$PS1"
- fi
-
- # Get the value of the prompt prefix, which will change $?
- \local iterm2_prompt_prefix_value="$(iterm2_prompt_prefix)"
-
- # Add the mark unless the prompt includes '$(iterm2_prompt_mark)' as a substring.
- if [[ $ITERM_ORIG_PS1 != *'$(iterm2_prompt_mark)'* && x$ITERM2_SQUELCH_MARK = x ]]
- then
- iterm2_prompt_prefix_value="$iterm2_prompt_prefix_value$(iterm2_prompt_mark)"
- fi
-
- # Send escape sequences with current directory and hostname.
- iterm2_print_state_data
-
- # Reset $? to its saved value, which might be used in $ITERM_ORIG_PS1.
- __bp_set_ret_value "$__iterm2_last_ret_value" "$__bp_last_argument_prev_command"
-
- # Set PS1 to various escape sequences, the user's preferred prompt, and more escape sequences.
- export PS1="\[$iterm2_prompt_prefix_value\]$ITERM_ORIG_PS1\[$(iterm2_prompt_suffix)\]"
-
- # Save the value we just set PS1 to so if the user changes PS1 we'll know and we can update ITERM_ORIG_PS1.
- export ITERM_PREV_PS1="$PS1"
- __bp_set_ret_value "$__iterm2_last_ret_value" "$__bp_last_argument_prev_command"
- }
-
- # Install my functions
- preexec_functions+=(__iterm2_preexec)
- precmd_functions+=(__iterm2_precmd)
-
- iterm2_print_state_data
- iterm2_print_version_number
- fi
-
- # -- END ITERM2 CUSTOMIZATIONS --
-
|